/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the DiscriminatorTypeFieldTrait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DiscriminatorTypeFieldTrait{}

// DiscriminatorTypeFieldTrait struct for DiscriminatorTypeFieldTrait
type DiscriminatorTypeFieldTrait struct {
	Type *string `json:"type,omitempty"`
}

// NewDiscriminatorTypeFieldTrait instantiates a new DiscriminatorTypeFieldTrait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDiscriminatorTypeFieldTrait() *DiscriminatorTypeFieldTrait {
	this := DiscriminatorTypeFieldTrait{}
	return &this
}

// NewDiscriminatorTypeFieldTraitWithDefaults instantiates a new DiscriminatorTypeFieldTrait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDiscriminatorTypeFieldTraitWithDefaults() *DiscriminatorTypeFieldTrait {
	this := DiscriminatorTypeFieldTrait{}
	return &this
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *DiscriminatorTypeFieldTrait) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DiscriminatorTypeFieldTrait) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *DiscriminatorTypeFieldTrait) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *DiscriminatorTypeFieldTrait) SetType(v string) {
	o.Type = &v
}

func (o DiscriminatorTypeFieldTrait) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DiscriminatorTypeFieldTrait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableDiscriminatorTypeFieldTrait struct {
	value *DiscriminatorTypeFieldTrait
	isSet bool
}

func (v NullableDiscriminatorTypeFieldTrait) Get() *DiscriminatorTypeFieldTrait {
	return v.value
}

func (v *NullableDiscriminatorTypeFieldTrait) Set(val *DiscriminatorTypeFieldTrait) {
	v.value = val
	v.isSet = true
}

func (v NullableDiscriminatorTypeFieldTrait) IsSet() bool {
	return v.isSet
}

func (v *NullableDiscriminatorTypeFieldTrait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDiscriminatorTypeFieldTrait(val *DiscriminatorTypeFieldTrait) *NullableDiscriminatorTypeFieldTrait {
	return &NullableDiscriminatorTypeFieldTrait{value: val, isSet: true}
}

func (v NullableDiscriminatorTypeFieldTrait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDiscriminatorTypeFieldTrait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
